
import java.util.Scanner;
import java.io.File;

class Itens //Item do cardapio
{
	int codigo
	def nome
	float preco
	int quantidade
	def item_cardapio = { " ${codigo}\t\tRS ${preco}\t\t${nome}\n" }
	def imprime = { "${nome};${quantidade};" }
}

def le_cardapio( String nome_arquivo ) // funcao que le o arquivo do cardapio e joga para uma lista
{
	
	def cardapio = []
	def aux = 0 // auxiliar usado para pular a primeira linha do cardapio
	def itemCardapio = new Itens()
	def line
	def file = new File(nome_arquivo)
	file.eachLine{
		if (aux == 0) // pula a primeira linha
		{
			aux++
			return
		}
		else
		{
			itemCardapio = new Itens()
			line = it.split(';')// divide a linha em um vetor de strings quebrando-a no ';' 
			itemCardapio.codigo = line[0].toInteger() 
			itemCardapio.nome = line [1]
			itemCardapio.preco = ((line[2]).replaceAll(',','.')).toFloat()
			cardapio << itemCardapio // adiciona ao final da lista do cardapio
		}
	}
	cardapio = cardapio.sort{it.codigo} //ordena a lista em ordem crescente do codigo do item
	cardapio //retorna a lista ordenada do cardapio
}

class Pedido 
{
	def nome
	def telefone
	def data
	def hora
	float valor
	def imprime = { " ${nome}\t\t${telefone}\t\t${data}\t\t${hora}\t\t${valor}\n" }
}

class Cliente
{
	def nome
	def telefone
	def endereco
	def ponto_referencia
	def cadastra_cliente(def tel_cadastro, def x) // joga o cliente para a lista
	{
		Scanner sc = new Scanner(System.in)
		def aux = 'a'
		telefone=tel_cadastro
		if (x==0)
		{
			print "\tNome: "
			nome = sc.nextLine()
			print "\tEndereco: "
			endereco = sc.nextLine()
			print "\tPonto de Referencia: "
			ponto_referencia = sc.nextLine()
		}
		while ((aux!='C')&&(aux!='c')&&(aux!='R')&&(aux!='r')) // enquanto a resposta nao for c ou r, continua no loop
		{
		
			print "Confirmar Cadastro: [C]onfirmar ou [R]ecadastrar"
			aux = sc.nextLine()
			if ((aux == 'C')||(aux == 'c')) return 0
			else if ((aux == 'R')||(aux == 'r')) 
			{
				print "Recadastrando cliente no telefone ${telefone} : \n"
				return cadastra_cliente(telefone,0)
			}
			else print "Opcao invalida, Tente Novamente\n\n"
		}
	}
}

def atendimento(def cardapio)
{
	def clientes = []
	def cliente_atual
	def pedidos = []
	def pedido_atual = new Pedido()
	int quant_aux = 0
	def x
	def aux = 'a'
	def Item_aux
	def confirma
	def cancela = []
	def cancela_aux
	Scanner sc = new Scanner(System.in)
	
	// Entra telefone do cliente
	print "\nTelefone ( 0 para sair):"
	def tel = sc.nextLine()
	
	while ( tel != "0" )
	{
		pedido_atual = new Pedido()
		x = 0
		clientes.each{if (it.telefone==tel) {cliente_atual =it;x=1;}}
		if (x == 0)
		{
			print "Cliente nao cadastrado. Novo cadastro:\n"
			cliente_atual = new Cliente()
		}
		cliente_atual.cadastra_cliente(tel,x)
		if (x==0) clientes << cliente_atual
		
		cancela = []
		cardapio.each {
			cancela_aux = new Itens()
			cancela_aux.codigo = it.codigo
			cancela_aux.nome = it.nome
			cancela_aux.preco = it.preco
			cancela_aux.quantidade = it.quantidade
			cancela << cancela_aux	
		}
		
		pedido_atual.nome = cliente_atual.nome
		pedido_atual.telefone = tel
		aux = 'a'
	
		while (aux != '0')
		{
			x = 0
			print '\nAdicionar item do cardapio (? para cardapio, 0 para finalizar):'
			aux=sc.nextLine()
			if (aux=='?')
			{
				cardapio.each{print it.item_cardapio()}
			} 
			else
			{
				cardapio.each{ 
					if ((it.codigo).toString() == aux)
					{
						Item_aux = new Itens()
						print "\nAdicionando ${it.nome} ao pedido. Quantidade:"
						quant_aux = (sc.nextLine()).toInteger()
						Item_aux.codigo = it.codigo
						Item_aux.nome = it.nome
						Item_aux.preco = it.preco 
						it.quantidade += quant_aux
						Item_aux.quantidade = quant_aux
						pedido_atual.valor += ((Item_aux.quantidade).toInteger())*(Item_aux.preco)
						x = 1
					}
				}
				if ((x == 0)&&(aux!='0')) print "Nao ha item com codigo ${aux} no cardapio\n"
			}			
		}
		
		print "\nTotal RS ${pedido_atual.valor} Cofirma?"
		confirma = sc.nextLine()
		
		if ((confirma == 'S')||(confirma == 's'))
		{
			pedidos << pedido_atual
		}
		else {
		cardapio = []
		cancela.each {
			cancela_aux = new Itens()
			cancela_aux.codigo = it.codigo
			cancela_aux.nome = it.nome
			cancela_aux.preco = it.preco
			cancela_aux.quantidade = it.quantidade
			cardapio << cancela_aux	
		}}
		
		print "\nTelefone ( 0 para sair):"
		tel = sc.nextLine() 
	}
	cardapio
}

if ((args.size()==4)){
	if((args[0]!='-e')||(args[2]!='-c')||((args[1])=='')||(args[3]=='')) print "Arquivos de entrada nao especificados. Use -e <entregadores> -c <cardapio>\n"
	else 
	{
		try
		{
			def cardapio = le_cardapio(args[3])
			cardapio = atendimento(cardapio)
			cardapio = cardapio.sort{it.nome}
			cardapio = cardapio.sort{a,b -> b.quantidade <=> a.quantidade}
			
			def file = new File("itemVendidos.csv").withWriter{ out ->
				out.writeLine("\nItem;Qtd. vendida;Pico de procura\n")
				cardapio.each{ 
					if ( it.quantidade >= 5 ) out.writeLine(it.imprime()+"Sim\n")
					else out.writeLine(it.imprime()+"Nao\n")
				}
			}
		} catch( Exception e ){ print "Erro na abertura do cardapio \n" }
	}
}
else print "Arquivos de entrada nao especificados. Use -e <entregadores> -c <cardapio>\n"



